/*
 * EtherPix config file generator
 *
 * Copyright 2010-2017 Stefan Schuermans <stefan schuermans info>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef INC_LINE_H
#define INC_LINE_H

#include "box.h"
#include "point.h"

class Line {
public:
  Line();
  Line(const Point &start, const Point &end);
  double length() const;
  void getBounds(Box &bounds) const;
  bool isIntersecting(const Line *pLine) const;
  bool getIntersection(const Line *pLline, Point *pIntersect) const;
  Point mStart, mEnd;
};

#endif // #ifndef INC_LINE_H

